using System;

namespace Events
{
    class Program
    {
        static void Main(string[] args)
        {
            // 2 observers observeren 1 watcher:
            CRateWatcher rw = new CRateWatcher();
            CRateObserver obs1 = new CRateObserver(rw, "One");
            CRateObserver obs2 = new CRateObserver(rw, "Two");

            rw.Notify("base", 5.7);
        }
    }

    public class CRateInfo : EventArgs
    {
        public string myRateName;
        public double myRateValue;

        public CRateInfo(string name,
            double rate)
        {
            myRateName = name;
            myRateValue = rate;
        }
    }

    public delegate void RateChangeHandler(
        object sender, CRateInfo info);

    public class CRateWatcher
    {
        public event RateChangeHandler OnRateChangeHandler;

        public void Notify(string name, double val)
        {
            if (OnRateChangeHandler != null)
            {
                OnRateChangeHandler(
                    this, new CRateInfo(name, val));
            }
        }
    }

    public class CRateObserver
    {
        private CRateWatcher myRateWatcher;
        private string myName;

        public CRateObserver(CRateWatcher r,
            string name)
        {
            myRateWatcher = r;
            myName = name;
            myRateWatcher.OnRateChangeHandler +=
                //new RateChangeHandler(RateHasChanged);
                // of kortweg (sinds C# 2.0) :
                RateHasChanged;
        }

        public void RateHasChanged(object sender,
            CRateInfo info)
        {
            Console.WriteLine("Observatie door " + myName + ":\tRate " + info.myRateName +
                " heeft nieuwe waarde = " + info.myRateValue);
        }

    }
}
