﻿using System;
using System.Xml.Linq;
using System.Linq;

namespace LINQToXML
{
    class Program
        // transforming XML with LINQ to SQL
    {
        static void Main(string[] args)
        {
            XDocument doc = XDocument.Load("students.xml");
            Console.WriteLine("voor transformatie:");
            Console.WriteLine(doc);

            // maak een nieuwe XML-tree, gesorteerd op achternaam,
            // met de gegevens van studenten die geen score kleiner dan 50 hebben
            // en wijzig de elementnamen
            XElement nieuw = new XElement("studentenlijst",
                from stud in doc.Root.Elements("student")
                let scores = stud.Element("Scores").Value.Split(new char[] { ',' })
                where scores.Min( s => Int32.Parse(s) ) >= 50
                orderby stud.Element("Last").Value
                select new XElement(
                    "student", 
                    new XAttribute("studiebeurs",true),
                    new XElement("naam", stud.Element("Last").Value),
                    new XElement("voornaam", stud.Element("First").Value)));


            Console.WriteLine("na transformatie:");
            Console.WriteLine(nieuw);
        }
    }
}
