﻿namespace ParallelComputing
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Diagnostics;

    public class PLINQ
    {
        static void Main(string[] args)
        {
            Stopwatch stopwatch = new Stopwatch();
            String[] matrozen = { "Jan", "Piet", "Joris", "Korneel" };

            stopwatch.Start();
            var qry1 = from String s in matrozen
                       where s.StartsWith("J")
                       orderby s.Length ascending
                       select DoSomeCPUConsumingProcessing(s);
            foreach (String s  in qry1)
            {
                Console.WriteLine(s);
            }
            stopwatch.Stop();
            Console.WriteLine("Sequential loop time in milliseconds: {0}", stopwatch.ElapsedMilliseconds);


            Console.WriteLine();

            stopwatch.Reset();
            stopwatch.Start();
            var qry = from String s in matrozen.AsParallel()
                      where s.StartsWith("J")
                      orderby s.Length ascending
                      select DoSomeCPUConsumingProcessing(s);
            foreach (String s in qry)
            {
                Console.WriteLine(s);
            }
            stopwatch.Stop();
            Console.WriteLine("Parallel loop time in milliseconds: {0}", stopwatch.ElapsedMilliseconds);
            
            
        }

        private static String DoSomeCPUConsumingProcessing(String matroos)
        {
            matroos = matroos.ToUpper();
            for (int i = 0; i < 100000000; i++)
            {
                // om effect van parallele uitvoering te testen
            }
            return matroos;
        }

    }
}
