﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;
using System.Threading.Tasks;

namespace ParallelComputing
{
    class ParallelForEach
    {
        static void Main(string[] args)
        {
            String[] matrozen =  { "Jan", "Piet", "Joris", "Korneel"};

            Stopwatch stopwatch = new Stopwatch();
            stopwatch.Start();
            foreach (String matroos in matrozen)
            {
                DoSomeCPUConsumingProcessing(matroos);
            }
            stopwatch.Stop();
            Console.WriteLine("Sequential loop time in milliseconds: {0}", stopwatch.ElapsedMilliseconds);

            Console.WriteLine();

            stopwatch.Reset();
            Console.WriteLine("Executing parallel loop...");
            stopwatch.Start();
            // sinds .net4: parallele uitvoering foreach
            Parallel.ForEach(matrozen, matroos => DoSomeCPUConsumingProcessing(matroos));
            stopwatch.Stop();
            Console.WriteLine("Parallel loop time in milliseconds: {0}", stopwatch.ElapsedMilliseconds);

        }

        private static void DoSomeCPUConsumingProcessing(String matroos)
        {
            matroos = matroos.ToUpper();
            for (int i = 0; i < 10000000; i++)
            {
                // om effect van parallele uitvoering te testen
            }
            Console.WriteLine(matroos);  // synchronous calls to shared resources like the Console or File System will significantly degrade performance of a parallel loop
        }
    }
}
