﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Schema;

namespace validatingreader
{
    class Program
    {
        static void Main(string[] args)
        {
            XmlReaderSettings settings = new XmlReaderSettings();
            settings.ValidationType = ValidationType.Schema;
            settings.ValidationFlags = XmlSchemaValidationFlags.ProcessSchemaLocation | XmlSchemaValidationFlags.ProcessIdentityConstraints;
            XmlSchemaSet sc = new XmlSchemaSet();
            sc.Add("http://beta.ua.ac.be/boek.xsd","boek.xsd");
            settings.Schemas = sc;
            settings.ValidationEventHandler += new ValidationEventHandler(settings_ValidationEventHandler);
            XmlReader reader = XmlReader.Create("boek.xml", settings);

            while (reader.Read())
            {
                //if (!bDoorgaan) break;
                if (reader.IsStartElement())
                {
                    Console.WriteLine("<" + reader.Name + ">");
                    if (reader.Name.Equals("boek"))
                    {
                        Console.WriteLine("id:" + reader.GetAttribute("id"));
                        Console.WriteLine("taal:" + reader.GetAttribute("taal"));
                    }
                }
                else if (reader.NodeType == XmlNodeType.Text)
                {
                    Console.WriteLine(reader.Value);
                }
            }
        }
        private static bool bDoorgaan = true;
        static void settings_ValidationEventHandler(object sender, ValidationEventArgs e)
        {
            Console.WriteLine(e.Message);
            bDoorgaan = false;
        }
    }
}
